// driver.h

#ifndef _DRIVER_H_
#define _DRIVER_H_

#include "common/h/Vector.h"
#include "util/h/StringPool.h"
#include "moduleMgr.h"
#include "kernelDriver.h"
#include "hiddenFns.h"

void doStuff(unsigned char *mmapptr, unsigned long filelen,
	     bool kernel, const char *justPrintRoutine);

void gather(bool verbose_memUsage,
            bool verbose_skips,
            bool verbose_returningFuncs,
            bool verbose_symbolTable,
            bool verbose_symbolTableTiming, // subset of above
            bool verbose_removeAliases,
            bool verbose_fnParse,
            bool verbose_fnParseTiming,
            bool verbose_summaryFnParse,
            bool verbose_hiddenFns,
            kernelDriver &,
            moduleMgr &theModuleMgr,
            dictionary_hash<kptr_t, bool> &interProcJumps,
            pdvector<hiddenFn> &hiddenFns);

void gather2(bool verbose_memUsage,
             bool verbose_summaryFnParse,
             bool verbose_fnParseTiming, // also passed to gather()
             bool verbose_resolveInterprocJumps,
             bool verbose_bbDFS,
             bool verbose_interProcRegAnalysis,
             bool verbose_interProcRegAnalysisTiming,
             bool verbose_numSuccsPreds,
             bool verbose_fnsFiddlingWithPrivRegs,
             moduleMgr &theModuleMgr,
             dictionary_hash<kptr_t, bool> &interProcJumps);

#endif
